/*
  (c) Copyright 2003, Hewlett-Packard Company, all rights reserved.
  [See end of file]
  $Id: AbstractARPPerfTest.java,v 1.2 2003/05/02 08:40:24 jeremy_carroll Exp $
*/
package com.hp.hpl.jena.test.performance;

import java.io.*;
import java.util.*;
import java.lang.reflect.Array;
import java.net.*;
/**
 * @author <a href="mailto:Jeremy.Carroll@hp.com">Jeremy Carroll</a>
 *
*/
abstract public class AbstractARPPerfTest extends AbstractPerfTest {
	byte data[];
	String url;
	static String DEFAULT_URL = "http://unknown.org/";
	protected void setupTest(int size) throws Exception {
		String defaultFileName = "rdf/" + size + "dmoz.rdf";
		String fileName =
			System.getProperty("jena.perftest.filename", defaultFileName);
		url = System.getProperty("jena.perftest.url", DEFAULT_URL);
		System.err.println("url: " + url);
		if ((!url.equals(DEFAULT_URL)) && fileName.equals(defaultFileName)) {
System.err.println("OK");
			URL u = new URL(url);
			Vector v = new Vector();
			InputStream in = u.openStream();
			// read the URL in 2048 byte blocks
			int totalRead = 0;
			int r = 0;
			do {
				totalRead += r;
				byte d[] = new byte[2048];
				r = in.read(d);
				v.add(d);
			} while (r != -1);
			data = new byte[totalRead];
			Iterator it = v.iterator();
			int p = 0;
			while (p < totalRead) {
				byte d[] = (byte[]) it.next();
				int lg = d.length;
				if (p + lg > totalRead)
					lg = totalRead - p;
			    System.err.println("p: "+p + " lg: "+lg);
				System.arraycopy(d, 0, data, p, lg);
				p += lg;
			}

		} else {

			// open and read the file
			File f = new File(fileName);
			FileInputStream in = new FileInputStream(f);
			data = new byte[(int) f.length()];
			in.read(data);
			in.close();
		}
		

	}

}

/*
	(c) Copyright Hewlett-Packard Company 2003
	All rights reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:

	1. Redistributions of source code must retain the above copyright
	   notice, this list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	3. The name of the author may not be used to endorse or promote products
	   derived from this software without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/